local newSettings = {
	geometryQualityOptions = {
			{ viewNearFar = { 4.0, 30000.0 }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 1.0 },		-- Low1
			{ viewNearFar = { 4.0, 30000.0 }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 1.0 },		-- Medium
			{ viewNearFar = { 4.0, 30000.0 }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 1.0 },		-- High
			{ viewNearFar = { 4.0, 50000.0 }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 10 },	-- Camera tool
			{ viewNearFar = { 0.5, 30000.0 }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 1.0 },		-- Cockpit view
	}
}
local newGui =  {
	landValueColors = {
		{ { 0.341, 0.709, 0.231, 1.0 }, { 0.109, 0.223, 0.074, 1.0 }, },
		{ { 0.235, 0.580, 0.764, 1.0 }, { 0.078, 0.184, 0.243, 1.0 }, },
		{ { 0.764, 0.725, 0.235, 1.0 }, { 0.254, 0.243, 0.082, 1.0 }, }
	},
	badGoodColors = { { 0.941, 0.168, 0.156, 1.0}, { 0.941, 0.815, 0.156, 1.0 }, { 0.149, 0.756, 0.062, 1.0 }, },
	neutralGoodColors = { { .6, .8, 1.0, 1.0 }, { .6, 1.0, 1.0, 1.0 }, { .6, 1.0, .6, 1.0 }, },
	
	contourLinesConfig = {
		numLevels = 6,
		baseColor = { .7, .7, .7, 1.0 },
		terrainMinColor = { .82, .82, .82, 1.0 },
		terrainMaxColor = { .235, .54, .25, 1.0 },
		waterColor = { .47, .64, .76, 1.0 },
		contours = {
			{ id = "majorContour", name = _("Major contour (100 m)"), color = { .05, .05, .05, .5 }, level = 100.0, width = 1.5, fadeDist = -1.0 },
			{ id = "minorContour", name = _("Minor contour (50 m)"), color = { .05, .05, .05, .5 }, level = 50.0, width = .75, fadeDist = -1.0 },
			{ id = "intermediateContour", name = _("Intermediate contour (10 m)"), color = { .2, .125, .0, .5 }, level = 10.0, width = .75, fadeDist = 4000.0 },
			{ id = "detailContour", name = _("Detail contour (2 m)"), color = { .2, .125, .0, .5 * 0.3 }, level = 2.0, width = .75, fadeDist = 500.0 }
		}
	},
	
	defaultChartColors = {
		{ .6, .8, 1.0, 1.0 },
		{ 1.0, .6, .6, 1.0},
		{ .525, .847, .345, 1.0 },
		{ .369, .839, .906, 1.0 },
		{ .875, .875, .384, 1.0 }
	},
	
	incomeCostsChartColors = { { .6, .8, 1.0, 1.0 }, { 1.0, .6, .6, 1.0} },
	loadedUnloadedChartColors = { { .6, .8, 1.0, 1.0 }, { 1.0, .6, .6, 1.0} },
	landUseChartColors = { { .525, .847, .345, 1.0 }, { .369, .839, .906, 1.0 }, { .875, .875, .384, 1.0 } },
	
	lineColors = {
		{ 0.96, 0.19, 0.21 },
		{ 1, 0.93, 0.13 },
		{ 0.4, 0.87, 0.25 },
		{ 0.27, 0.69, 1 },
		{ 0.79, 0.3, 0.81 },
		{ 0.92, 0.46, 0.15 },
		{ 0.54, 0.31, 0.15 },
		{ 0, 0.43, 0.12 },
		{ 0.16, 0.31, 0.57 },
		{ 0.37, 0.17, 0.53 },
		{ 0.83, 0.39, 0.44 },
		{ 0.84, 0.64, 0.3 },
		{ 0.71, 0.83, 0.4 },
		{ 0.4, 0.82, 0.65 },
		{ 0.62, 0.54, 0.82 },
		{ 0.49, 0.16, 0.29 },
		{ 0.34, 0.32, 0.24 },
		{ 0.47, 0.52, 0.21 },
		{ 0.07, 0.56, 0.6 },
		{ 0.40, 0.25, 0.83 },
	},
	
	modifierColors = {
		{ 1.0, .0, .0, .3 },
		{ 1.0, .0, .0, .4 }, 	-- tunnel edges
		{ 1.0, .0, .0, .6 }, 	-- proposal
		{ 1.0, .0, .0, .75 }, 	-- proposal: tunnel edges
		{ .0, .4, 1.0, .4 },
		{ .0, .4, 1.0, .5 },  	-- tunnel edges
		{ .0, .4, 1.0, .6 }, 	-- proposal
		{ .0, .4, 1.0, .75 }  	-- proposal: tunnel edges
	}
}

local newtrainBrakeDeceleration = 1.25

function data()
return {
	info = {
		minorVersion = 8,
		severityAdd = "NONE",
		severityRemove = "NONE", 
		name = _("Natural Environment Professional"),
		description = _("NEP Beschreibung"),
		tags = { "Europe", "Shader" },
		authors = {
			{
				name = 'UnixRoot',
				role = 'CREATOR',
				text = 'Texturen, Idee',
			},
		},
		params = {
			{
				key = "renderDistance",
				name = _("Render Distance"),
				uiType = "SLIDER",
				values = { _("10km"), _("20km"), _("30km"), _("40km"), _("50km"),},
				tooltip = _("Choose the render distance."),
				defaultIndex = 2,
			},{
				key = "environment",
				name = _("Environment"),
				uiType = "COMBOBOX",
				values = { _("standard_nep"),_("less_blue_nep"),_("nep_um_6") },
				tooltip = _("skybox_tooltip"),
				defaultIndex = 0,
			},
		}
	},
	runFn = function (settings, modParams)
	
		local environments = {
			[0] = "nep_temperate.lua",
			[1] = "nep_temperate_less_blue.lua",
			[2] = "nep_um_6.lua",
		}
	
		if modParams[getCurrentModId()] ~= nil then
			local params = modParams[getCurrentModId()]
			local distanceFactor = 3
			
			if params["renderDistance"] ~= nil then
				distanceFactor = params["renderDistance"] / 4
			end
			--local distanceFactor = params["renderDistance"] / 4
			
			game.config.settings = {
				geometryQualityOptions = {
					{ viewNearFar = { 4.0, 10000.0 	+ distanceFactor * 40000 }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 1.0 },		-- Low
					{ viewNearFar = { 4.0, 10000.0 	+ distanceFactor * 40000 }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 1.0 },		-- Medium
					{ viewNearFar = { 4.0, 10000.0 	+ distanceFactor * 40000 }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 1.0 },		-- High
					{ viewNearFar = { 4.0, 50000.0 }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 10 },	-- Camera tool
					{ viewNearFar = { 0.5, 10000.0 	+ distanceFactor * 40000  }, fogStartEndFarPerc = { 0, 1.0 }, lodDistanceScaling = 1.0 },		-- Cockpit view
				}
			}game.config.environment = environments[params["environment"]]
			
		else
			game.config.settings = newSettings
			game.config.environment = "nep_temperate.lua"
		end
		game.config.trainBrakeDeceleration = newtrainBrakeDeceleration
		game.config.gui =  newGui
	end,
	postRunFn = function ()
	
		local filteredModules = {			
			["trainstation_high_speed_lzb.lua"] 				= 1,
			["trainstation_high_speed_lzb.luacatenary"] 		= 1,
			["trainstation_low_speed.lua"] 						= 1,
			["trainstation_low_speed.luacatenary"] 				= 1,
		}
			
		local modules = api.res.moduleRep.getAll()
		for index, moduleFileName in ipairs(modules) do
			if filteredModules[moduleFileName] == 1 then
				api.res.moduleRep.setVisible(index - 1,false)
			end
		end
	end
}
end

