#version 150
#extension GL_ARB_texture_gather : enable
/// BEGIN AUTOGENERATED HEADER
#define CONC(a,b) a##b

#define IF(c, t, e) CONC(IF_, c)(t, e)

#define IF_UNDEF(t, e) e
#define IF_0(t, e) t
#define IF_1(t, e) t
#define IF_2(t, e) t
#define IF_3(t, e) t
#define IF_4(t, e) t
#define IF_5(t, e) t
#define IF_6(t, e) t
#define IF_7(t, e) t
#define IF_8(t, e) t
#define IF_9(t, e) t
#define IF_10(t, e) t
#define IF_11(t, e) t
#define IF_12(t, e) t
#define IF_13(t, e) t
#define IF_14(t, e) t
#define IF_15(t, e) t
#define IF_16(t, e) t
// Workaround for intel HD:
#define IF_00(t, e) t
#ifdef GL_SPIRV
	#define gl_VertexID gl_VertexIndex
	
	#define LAYOUT_SAMPLER2(s, b) layout(set = s, binding = b)
	#define LAYOUT_SAMPLER(s, b) layout(set = s, binding = b)
	#define LAYOUT_UBO(s, b) layout(std140, set = s, binding = b)
	#define LAYOUT_PUSH_CONSTANT() layout(push_constant, std140)

	#define VERTEX_INPUT(loc, type, name, defaultValue) IF(loc, layout (location = loc) in type name, const type name = defaultValue)
		
	#define INPUT_MOD(loc, mod, type, name, defaultValue) IF(loc, layout (location = loc) mod in type name, const type name = defaultValue)
		
	#define INPUT(loc, type, name, defaultValue) IF(loc, layout (location = loc) in type name, const type name = defaultValue)

	#define OUTPUT(loc, type, name) IF(loc, layout (location = loc) out type name, type name)
	
	#define OUTPUT_MOD(loc, mod, type, name) IF(loc, layout (location = loc) mod out type name, type name)
	
	#define WINDING ccw

	#define LOCATION(loc) layout(location = loc) 
#else
	#extension GL_ARB_separate_shader_objects : require
	#extension GL_ARB_explicit_attrib_location : require
	#extension GL_ARB_shading_language_420pack : require

#ifdef USE_SAMPLER2
	#define LAYOUT_SAMPLER2(s, b)
#else
	#define LAYOUT_SAMPLER2(s, b) layout(binding = b)
#endif

	#define LAYOUT_SAMPLER(s, b) layout(binding = b)
	#define LAYOUT_UBO(s, b) layout(std140, binding = b)
	#define LAYOUT_PUSH_CONSTANT() layout(std140, binding = 2)

	#define VERTEX_INPUT(loc, type, name, defaultValue) IF(loc, layout (location = loc) in type name, const type name = defaultValue)
		
	#define INPUT_MOD(loc, mod, type, name, defaultValue) mod in type name
		
	#define INPUT(loc, type, name, defaultValue) in type name

	#define OUTPUT(loc, type, name) out type name
	
	#define OUTPUT_MOD(loc, mod, type, name) mod out type name
	
	#define WINDING ccw

	#define LOCATION(loc)
#endif
/// END AUTOGENERATED HEADER

LAYOUT_SAMPLER(1, 26) uniform sampler2DArray colorArrayTex;
// uniform sampler2DArray translucencyTex; // currently not used
// uniform sampler2DArray normalTex;		// currently not used
LAYOUT_SAMPLER(1, 28) uniform sampler2DArray glossTex;
LAYOUT_SAMPLER(1, 29) uniform sampler2DArray overlayTex;

LAYOUT_UBO(0, 10) uniform View {
	mat4 projView;
	mat4 projViewInverse;
	mat4 proj;
	mat4 projInverse;
	mat4 view;
	mat4 viewInverse;
	vec3 camPos;
	float lodFactor;
	float near;
	float far;
} u_view;

LAYOUT_UBO(0, 6) uniform Light {
	vec3 lightDir;
	float lightScale;
	mat4 lightTransf;
	mat4 lightInvTransf;
	float ambientScale;
} u_light;

LAYOUT_UBO(1, 15) uniform MatDataBlock {
	vec4 mat2grassOverlayScaling[256];
} u_matDataBlock;

LAYOUT_PUSH_CONSTANT() uniform PushConstant {
	vec4 blockCoordDim;
	vec2 tileSubPos;
	vec2 tileOffset;
	float distanceScaling;
	float alphaThreshold;
	int numSamples;
	vec4 color;
} u_push; // TODO

INPUT(VPOS_LOC, vec3, vpos, vec3(1.0));
INPUT(NRML_LOC, vec3, normal_, vec3(1.0));
INPUT(TNGT_LOC, vec3, tangentAmb_, vec3(1.0));
INPUT(TC_LOC, vec2, texCoord, vec2(1.0));
INPUT_MOD(MATTYPE_LOC, flat, ivec2, grassMatType, vec2(1.0));

vec4 applyFog(vec4 color);
vec3 overlay(vec4 col0, vec3 col1);
void fragmentOutputCustom(vec4 color, vec4 normal);
vec4 lightPhys(vec3 pos, float ambient, vec3 normal, vec3 albedo, float metalness, float glossiness, float alpha);

void main() {
	vec3 texCoordGrassType = vec3(texCoord, float(grassMatType.x));
	
	vec3 terrainNormal = normalize(normal_);
	vec3 tangent = normalize(vec3(tangentAmb_.xy, 0.0));
	
	vec3 faceNormal = vec3(-tangent.y, tangent.x, .0);
	
	vec4 col = texture(colorArrayTex, texCoordGrassType);
	if (col.a < u_push.alphaThreshold) discard;
		
	vec4 scaleStrength = u_matDataBlock.mat2grassOverlayScaling[grassMatType.y];
	vec3 col1 = texture(overlayTex, vec3(vpos.xy * scaleStrength.y, grassMatType.y)).rgb; // use matIndex
	col.rgb = overlay(vec4(col.rgb, scaleStrength.z), col1) * .7;
	
	vec3 metalGlossAo = texture(glossTex, texCoordGrassType).rgb;
	
	vec3 camVertex = vpos - u_view.viewInverse[3].xyz;

	if (dot(faceNormal, camVertex) > .0) {
		faceNormal = -faceNormal;
	}
	
	float w0 = .2;
	
	float lightDot = dot(u_light.lightDir, faceNormal);
	if (lightDot < .0) {
		w0 = min(.2 + 1.0 * -lightDot, .6);
	}	

	float w1 = 1.0 - w0;

	float w = w0 + w1 * clamp((length(camVertex) - 50.0) / 100.0, .0, 1.0);
	vec3 normal = normalize(w * terrainNormal + (1.0 - w) * faceNormal * 0.2 );
	
	vec4 outCol = applyFog(lightPhys(vpos, metalGlossAo.b * tangentAmb_.z, normal, col.rgb, 0.0, -1.0, col.a));
		
		// outCol.rgb = vec3(1.0, 0.0, 0.0);
	fragmentOutputCustom(outCol, vec4(faceNormal, 1.0));
}
