#version 150
/// BEGIN AUTOGENERATED HEADER
#define CONC(a,b) a##b

#define IF(c, t, e) CONC(IF_, c)(t, e)

#define IF_UNDEF(t, e) e
#define IF_0(t, e) t
#define IF_1(t, e) t
#define IF_2(t, e) t
#define IF_3(t, e) t
#define IF_4(t, e) t
#define IF_5(t, e) t
#define IF_6(t, e) t
#define IF_7(t, e) t
#define IF_8(t, e) t
#define IF_9(t, e) t
#define IF_10(t, e) t
#define IF_11(t, e) t
#define IF_12(t, e) t
#define IF_13(t, e) t
#define IF_14(t, e) t
#define IF_15(t, e) t
#define IF_16(t, e) t
// Workaround for intel HD:
#define IF_00(t, e) t
#ifdef GL_SPIRV
	#define gl_VertexID gl_VertexIndex

	#define LAYOUT_SAMPLER2(s, b) layout(set = s, binding = b)
	#define LAYOUT_SAMPLER(s, b) layout(set = s, binding = b)
	#define LAYOUT_UBO(s, b) layout(std140, set = s, binding = b)
	#define LAYOUT_PUSH_CONSTANT() layout(push_constant, std140)

	#define VERTEX_INPUT(loc, type, name, defaultValue) IF(loc, layout (location = loc) in type name, const type name = defaultValue)
		
	#define INPUT_MOD(loc, mod, type, name, defaultValue) IF(loc, layout (location = loc) mod in type name, const type name = defaultValue)
		
	#define INPUT(loc, type, name, defaultValue) IF(loc, layout (location = loc) in type name, const type name = defaultValue)

	#define OUTPUT(loc, type, name) IF(loc, layout (location = loc) out type name, type name)
	
	#define OUTPUT_MOD(loc, mod, type, name) IF(loc, layout (location = loc) mod out type name, type name)
	
	#define WINDING ccw

	#define LOCATION(loc) layout(location = loc) 
#else
	#extension GL_ARB_separate_shader_objects : require
	#extension GL_ARB_explicit_attrib_location : require
	#extension GL_ARB_shading_language_420pack : require

#ifdef USE_SAMPLER2
	#define LAYOUT_SAMPLER2(s, b)
#else
	#define LAYOUT_SAMPLER2(s, b) layout(binding = b)
#endif

	#define LAYOUT_SAMPLER(s, b) layout(binding = b)
	#define LAYOUT_UBO(s, b) layout(std140, binding = b)
	#define LAYOUT_PUSH_CONSTANT() layout(std140, binding = 2)

	#define VERTEX_INPUT(loc, type, name, defaultValue) IF(loc, layout (location = loc) in type name, const type name = defaultValue)
		
	#define INPUT_MOD(loc, mod, type, name, defaultValue) mod in type name
		
	#define INPUT(loc, type, name, defaultValue) in type name

	#define OUTPUT(loc, type, name) out type name
	
	#define OUTPUT_MOD(loc, mod, type, name) mod out type name
	
	#define WINDING ccw

	#define LOCATION(loc)
#endif
/// END AUTOGENERATED HEADER

LAYOUT_SAMPLER2(0, 22) uniform samplerCube skyTex;

LAYOUT_UBO(0, 10) uniform View {
	mat4 projView;
	mat4 projViewInverse;
	mat4 proj;
	mat4 projInverse;
	mat4 view;
	mat4 viewInverse;
	vec3 camPos;
	float lodFactor;
	float near;
	float far;
} u_view;

LAYOUT_UBO(0, 6) uniform Light {
	vec3 lightDir;
	float lightScale;
	mat4 lightTransf;
	mat4 lightInvTransf;
	float ambientScale;
} u_light;

LAYOUT_UBO(0, 5) uniform Atmosphere {
	float fogDensity;
	vec2 fogDist;
	vec3 sunColor;
	vec3 rayleighExtCoeff;
	float rayleighScaleHeight;
	vec3 mieScattCoeff;
	float mieScaleHeight;
	float phaseG;
	float viewSamples;
} u_atmosphere;

INPUT(VPOS_LOC, vec3, vpos, vec3(1.0));
INPUT(FOGFACT_LOC, float, fogFactor, float(1.0));
INPUT(EXTFACT_LOC, vec3, extFactor, vec3(1.0));
INPUT(INSCATT_LOC, vec3, inScatt, vec3(1.0));

vec4 getLight(samplerCube lightTex, vec3 dir, float lod);

vec3 applyFog(vec3 color) {
	vec3 viewVec = normalize(vpos - vec3(u_view.viewInverse[3]));
	vec3 scattMulti = vec3(-0.01, 1.33, 2.66);
	vec3 skyColor0 = getLight(skyTex, viewVec, 0).rgb;
	vec3 skyColor1 = getLight(skyTex, viewVec, 6).rgb;
	
	float skyFogFactor = clamp((fogFactor - .8) * 5.0, .0, 1.0);
	
	vec3 skyColor = mix(skyColor1, skyColor0, skyFogFactor);

	return mix(color * extFactor + (u_atmosphere.sunColor + scattMulti) * inScatt, u_light.lightScale * skyColor, fogFactor);
}

vec4 applyFog(vec4 color) {
	return vec4(applyFog(color.rgb), color.a);
}
